/*
** $VER: CfgUUDecode.thor 1.1 (13.11.95)
** by Troels Walsted Hansen <troels@stud.cs.uit.no>
**
** Configuration editor for UUDecode.thor
**
** Based heavily on CfgSortMail.thor by Eirik Nicolai Synnes
*/

options results

/* Initialize some variables */

filenotes = 1; filerecog = 1; filetypecount = 0; tmpdir = 'T:'; destdir = 'GLOBAL'; uudecoder = 'NONE'; uuprogpath = ''; uudecoder.count = 0
namehelp = 'You can use a ''_'' to create a shortcut in the \nrequester which pops up. ''S'' is already used,\nso don''t put a ''_'' in front of an ''S''.'
cmdlinehelp = 'You can use the following tokens, which will be\ntranslated before the commandline is executed.\n\n%%FileName -> name of the decoded file\n%%ThorScreen -> name of THOR''s public screen\n%%RequestDir -> name of dir gotten with a filerequester\n%%RequestFile -> name of file gotten with a filerequester\n\nAnd you may use either of these internal commands,\nwhich show data in THOR''s main listview.\n\nSHOWPICTURE %%FileName [CLEAR]\nSHOWTEXT %%FileName'
uucmdlinehelp = 'You MUST use the following tokens, which will be translated\nbefore the commandline is executed.\n\n%%TmpFile -> a temporary file for erroroutput from the uudecoder.\n             You MUST redirect all output to this file.\n%%MsgFilename ->path and filename of the textfile with the file(s)\n%%DestDir -> destination directory for the decoding\n\nDo NOT use any real paths in this commandline, use only the tokens\ndescribed above. UUDecode.thor will not work correctly otherwise.'

/* Open THOR and BBSREAD ARexx ports' */

p=' '||address()||' '||show('P',,);if pos(' THOR.',p)>0 then thorport=word(substr(p,pos(' THOR.',p)+1),1);else do;say 'No THOR port found!';exit(0);end
if ~show('p', 'BBSREAD') then do; address command; "run >nil: `GetEnv THOR/THORPath`bin/LoadBBSRead"; "WaitForPort BBSREAD"; end

address(thorport)

/* See if another copy of CfgUUDecode is already running */

if exists("T:CfgUUDecode.tmp") then
do
	REQUESTNOTIFY '"Another copy of CfgUUDecode\nis probably running."' '"_Continue|_Abort"'
	if result = 0 then exit(0)
end

call open(tmp, "T:CfgUUDecode.tmp", 'W'); call close(tmp)

/* Find configuration file and read it*/

call open(pn, 'ENV:Thor/THORPATH')
thorpath = readln(pn)
call close(pn)

if ~exists(thorpath'rexx') then cfgfile = 'ENV:Thor/UUDecode.cfg'
else do
 if exists(thorpath'rexx/UUDecode.cfg') then cfgfile = thorpath'rexx/UUDecode.cfg'
 else cfgfile = 'ENV:Thor/UUDecode.cfg'
 end

CURRENTSYSTEM STEM bbs
if rc > 1 then 
do
	REQUESTNOTIFY '"'THOR.LASTERROR'"' '"_Abort"'
	exit(0)
end

if ~exists(cfgfile) then call writecfg(cfgfile)

call readcfg

mainmenu:
/* Display main menu */
menulist.1 = 'Change active uudecoder:           'uudecoder
menulist.2 = 'Change path to uudecoder:          'uuprogpath
menulist.3 = 'Change temporary directory:        'tmpdir
menulist.4 = 'Change destination directory:      'destdir
menulist.5 = ''
menulist.6 = 'Add filenotes to files:            '; if(filenotes) then menulist.6 = menulist.6 || 'YES'; else menulist.6 = menulist.6 || 'NO'
menulist.7 = 'Use filetyperecognition:           '; if(filerecog) then menulist.7 = menulist.7 || 'YES'; else menulist.7 = menulist.7 || 'NO'
menulist.8 = ''
menulist.9 = 'Configure filetypes'
menulist.10 = 'Configure uudecoders'
menulist.11 = ''
menulist.12 = 'HELP                               '

menulist.count = 12

address(thorport)
REQUESTLIST INSTEM menulist TITLE '"CfgUUDecode 1.1 by Troels Walsted Hansen"' SIZEGADGET
if rc ~= 0 then do
	if exists("T:CfgUUDecode.tmp") then do
		address(command)
		"Delete T:CfgUUDecode.tmp QUIET"
		end
	exit(0)
	end
choice = result

/* Check user input */
select
	when choice = menulist.1 then 
	do
		do i=1 to uudecoder.count
			uumenu.i = uudecoder.i.longname
		end

		uumenu.count = uudecoder.count

		address(thorport)
		REQUESTLIST INSTEM uumenu TITLE '"Select uudecoder:"' SIZEGADGET
		if rc ~= 0 then break

		do i=1 to uudecoder.count
			if(result = uudecoder.i.longname) then uudecoder = uudecoder.i.shortname
		end

		call writecfg(cfgfile)
	end

	when choice = menulist.2 then
	do
		address(thorport)
		REQUESTSTRING TITLE '"Enter uudecoder path"' BT '"_Ok|_Cancel"' ID '"'uuprogpath'"' BODY '"You may either enter the path to your\nchosen uudecoder program here, or your\nmay leave the stringgadget empty if the\nuudecoder program is in your path."' MAXCHARS 256
		if(rc = 0) then uuprogpath = result

		endchar = right(uuprogpath, 1)
		if(endchar ~= ":" & endchar ~= "/") then uuprogpath = uuprogpath || '/'

		call writecfg(cfgfile)
	end

	when choice = menulist.3 then
	do
		address(thorport)
		REQUESTSTRING TITLE '"Enter temporary directory"' BT '"_Ok|_Cancel"' ID '"'tmpdir'"' BODY '"Enter a path to suitable temporary directory\nfor UUDecode.thor. If you intend to decode\nmany, large files it had better be a\ndirectory/device with plenty of space."' MAXCHARS 256
		if(rc = 0) then tmpdir = result

		endchar = right(tmpdir, 1)
		if(endchar ~= ":" & endchar ~= "/") then tmpdir = tmpdir || '/'

		call writecfg(cfgfile)
	end

	when choice = menulist.4 then
	do
		address(thorport)
		REQUESTSTRING TITLE '"Enter destination directory"' BT '"_Ok|_Cancel"' ID '"'destdir'"' BODY '"Enter a path to where you want all decoded files\nto end up. If you enter GLOBAL, the global\ndownload dir configured in THOR, will be used."' MAXCHARS 256
		if(rc = 0) then destdir = result

		endchar = right(destdir, 1)
		if((endchar ~= ":" & endchar ~= "/") & upper(destdir) ~= 'GLOBAL') then destdir = destdir || '/'

		call writecfg(cfgfile)
	end

	when choice = menulist.6 then
	do
		address(thorport)
		REQUESTNOTIFY TEXT '"Would you like to have UUDecode.thor add a\nfilenote to decoded files, stating who sent\nthe message, and in which conference and on\nwhich system the file was found?"' BT '"_Yes|_No"'
		if(result = 0) then filenotes = 0
		else filenotes = 1

		call writecfg(cfgfile)
	end

	when choice = menulist.7 then
	do
		address(thorport)
		REQUESTNOTIFY TEXT '"Would you like to have UUDecode.thor try\nto recognize the type of decoded files,\nbased on their extensions, in order to\nperform actions you define on them?"' BT '"_Yes|_No"'
		if(result = 0) then filerecog = 0
		else filerecog = 1

		call writecfg(cfgfile)
	end

	when choice = menulist.9 then call cfgfiletype
	when choice = menulist.10 then call cfguudecoder

	when choice = menulist.12 then 
	do
		address(thorport)
		REQUESTNOTIFY TEXT '"Not implemented yet..."' BT '"_Ok"'
		/*call help('MAIN')*/
	end

	otherwise nop
	end

signal mainmenu

/*
** Procedures
*/

help: procedure expose mvopen thorport thorpath
			parse arg node

if node = 'MAIN' then page = 1
if node = 'CFGML' then page = 2
if node = 'CFGDG' then page = 3

if index(show('P',,), 'MV_UUDecode') = 0 then do
	address(thorport)
	GETGLOBALCONFIG STEM GLOBCFG

	/* Check version of MultiView? */
	address(command)
	'Run >NIL: MultiView FILE 'thorpath'Docs/UUDecode.guide PORTNAME MV_UUDecode PUBSCREEN 'GLOBCFG.PUBSCREENNAME
	'WaitForPort MV_UUDecode'
	if rc ~= 0 then do
		address(thorport)
		REQUESTNOTIFY '"Couldn''t start MultiView."' '"Sigh"'
		return
		end
	end

address(MV_UUDecode)
DOTRIGGERMETHOD CONTENTS
do i = 1 to page; DOTRIGGERMETHOD NEXT; end
return

cfgfiletype: procedure expose thorport thorpath tmpdir destdir uudecoder uuprogpath filenotes filerecog filetypecount filetype. uudecoder. cfgfile cmdlinehelp namehelp

filetypemenu:

menulist.1 = 'Add new filetype'
menulist.2 = 'Edit filetype'
menulist.3 = 'Delete filetype'
menulist.count = 3

address(thorport)
REQUESTLIST INSTEM menulist TITLE '"Configure filetypes"' SIZEGADGET
if rc ~= 0 then return
choice = result

if choice = menulist.1 then signal addfiletype
if choice = menulist.2 then signal editfiletype
if choice = menulist.3 then signal delfiletype
signal filetypemenu


addfiletype:
REQUESTSTRING TITLE '"Enter filetype name"' BODY '"Use a format like ''a picture'' or ''an archive'' if\nyou like grammatically correct sentences. :-)"' BT '"_Ok|_Cancel"' ID '"a"' MAXCHARS 80
if rc ~= 0 then signal filetypemenu

filetypecount = filetypecount + 1
filetype.filetypecount.name = result
namenr = filetypecount
filetype.namenr.actioncount = 0

edit = 0

signal editfiletypedata

editfiletype:
if filetypecount > 0 then
do
	do n = 1 to filetypecount; filetypelist.n = filetype.n.name; end
	filetypelist.count = filetypecount
	REQUESTLIST INSTEM filetypelist TITLE '"Select a filetype"' SIZEGADGET
	if rc ~= 0 then signal filetypemenu
	thisname = result
	do n = 1 to filetypecount; if thisname = filetype.n.name then namenr = n; end
end
else
do
	REQUESTNOTIFY '"There are no configured filetypes."' '"_Abort"'
	signal filetypemenu
end

edit = 1

editfiletypedata:
if(filetype.namenr.ext = 'FILETYPE.'namenr'.EXT') then filetype.namenr.ext = 'NONE'
thisname = filetype.namenr.name

editfiletypemenu:
menulist.1 = 'Change matching fileextension(s): ' || filetype.namenr.ext

menulist.2 = 'Add action'; addaction = 2; n = 3
do i = 1 to filetype.namenr.actioncount
	menulist.n = ' 'filetype.namenr.actionname.i
	n = n + 1
end

menulist.n = ''; n = n + 1
menulist.n = 'HELP'

menulist.count = n

REQUESTLIST INSTEM menulist TITLE '"' || 'Filetype: ' || thisname || '"' SIZEGADGET
if rc ~= 0 then
do
	call writecfg(cfgfile)
	signal filetypemenu
end
choice = result

select
	when choice = menulist.1 then
	do
		REQUESTSTRING TITLE '"Enter fileextensions for this action"' BODY '"You may use comma to separate file-\nextensions which you want to match.\n'ALL' will match all files."' BT '"_Ok|_Cancel"' ID '"'filetype.namenr.ext'"' MAXCHARS 40
		if rc ~= 0 then signal editfiletypemenu
		else filetype.namenr.ext = result

		call writecfg(cfgfile)
	end

	when choice = menulist.addaction then
	do
		filetype.namenr.actioncount = filetype.namenr.actioncount + 1
		actions = filetype.namenr.actioncount

		REQUESTSTRING TITLE '"Enter a name for this action"' BODY '"'namehelp'"' BT '"_Ok|_Cancel"' ID '"_"' MAXCHARS 40
		if rc ~= 0 then
		do
			filetype.namenr.actioncount = filetype.namenr.actioncount - 1
			signal editfiletypemenu
		end
		else filetype.namenr.actionname.actions = result

		REQUESTSTRING TITLE '"Enter a commandline for this action"' BODY '"'cmdlinehelp'"'	BT '"_Ok|_Cancel"' ID '"Run <>NIL: <COMMAND> *"%FileName*" PUBSCREEN=*"%ThorScreen*""'	MAXCHARS 256
		if rc ~= 0 then
		do
			filetype.namenr.actioncount = filetype.namenr.actioncount - 1
			signal editfiletypemenu
		end
		else filetype.namenr.actioncmdl.actions = result

		call writecfg(cfgfile)
	end

	when choice = 'HELP' then 
	do
		REQUESTNOTIFY TEXT '"Not implemented yet..."' BT '"_Ok"'
		/*call help('CFGfiletype')*/
	end

	otherwise 
	do
		do i = 1 to filetype.namenr.actioncount
			if choice = filetype.namenr.actionname.i then
			do
				REQUESTNOTIFY '"Do you want to edit\nor delete this item?"' '"_Edit|_Delete"'
				if result = 0 then 
				do
					REQUESTNOTIFY '"Sure you want to remove\n'choice'\nas an action?"' '"_Yes|_No"'
					if result = 1 then 
					do
						k = 1
						do j = 1 to filetype.namenr.actioncount
							if filetype.namenr.actioname.j ~= choice then
							do
								filetype.namenr.actioname.k = filetype.namenr.actioname.j
								k = k + 1
							end
						end
						filetype.namenr.actioncount = filetype.namenr.actioncount - 1
						call writecfg(cfgfile)
					end
				end
				else 
				do
					REQUESTSTRING TITLE '"Edit action name"' BODY '"'namehelp'"' BT '"_Ok|_Cancel"' ID '"'filetype.namenr.actionname.i'"' MAXCHARS 40
					if rc = 0 then 
					do
						filetype.namenr.actionname.i = result

						tmpstr = escape(filetype.namenr.actioncmdl.i) /* escape " -> *" & * -> ** */

						REQUESTSTRING TITLE '"Edit action commandline"' BODY '"'cmdlinehelp'"' BT '"_Ok|_Cancel"' ID '"'tmpstr'"' MAXCHARS 256
						if rc = 0 then
						do
							filetype.namenr.actioncmdl.i = result
							call writecfg(cfgfile)
						end
					end
				end
			end
		end
	end
end

signal editfiletypemenu

delfiletype:

if filetypecount > 0 then
do
	do n = 1 to filetypecount; filetypelist.n = filetype.n.name; end
	filetypelist.count = filetypecount
	REQUESTLIST INSTEM filetypelist TITLE '"Select a filetype to delete"' SIZEGADGET
	if rc ~= 0 then signal filetypemenu
	delfiletype = result
	REQUESTNOTIFY '"Do you want to remove this filetype from\nUUDecode''s configuration?"' "Yes|_No"
	if result = 0 then signal filetypemenu
	counter = 1

	do n = 1 to filetypecount
		if filetype.n.name = delfiletype then n = n + 1
		filetype.counter.name = filetype.n.name

		if actioncount > 0 then
		do m = 1 to filetype.counter.actioncount
			filetype.counter.actionname.m = filetype.n.actionname.m
			filetype.counter.actioncmdl.m = filetype.n.actioncmdl.m
		end

		counter = counter + 1
		if counter > filetypecount then leave
	end

	filetypecount = filetypecount - 1
	call writecfg(cfgfile)
end
else REQUESTNOTIFY TEXT '"There are no configured filetypes."' BT '"_Abort"'

signal filetypemenu

cfguudecoder: procedure expose thorport thorpath tmpdir destdir uuprogpath uudecoder uudecoder. filenotes filerecog filetypecount filetype. cfgfile uucmdlinehelp
uudecodermenu:

menulist.1 = 'Add new uudecoder'; n = 2
do i = 1 to uudecoder.count
	menulist.n = ' 'uudecoder.i.longname
	n = n + 1
end

menulist.n = ''; n = n + 1
menulist.n = 'HELP'

menulist.count = n

address(thorport)
REQUESTLIST INSTEM menulist TITLE '"Configure uudecoders"' SIZEGADGET
if rc ~= 0 then return
choice = result

select
	when choice = menulist.1 then
	do
		uudecoder.count = uudecoder.count + 1
		uudecoders = uudecoder.count

		REQUESTSTRING TITLE '"Enter a short name for this uudecoder"' BODY '"I.e. ''UUOUT'' or ''UUXT''."' BT '"_Ok|_Cancel"' ID '"UU"' MAXCHARS 40
		if rc ~= 0 then
		do
			uudecoder.count = uudecoder.count - 1
			signal uudecodermenu
		end
		else uudecoder.uudecoders.shortname = result

		REQUESTSTRING TITLE '"Enter a long, descriptive name this uudecoder"' BODY '"I.e. ''uuOut v1.14 by Nicolas Dade''\nor ''UUxT v3.1 by Asher Feldman''"' BT '"_Ok|_Cancel"' ID '"UU vx.xx by John Doe"' MAXCHARS 256
		if rc ~= 0 then
		do
			uudecoder.count = uudecoder.count - 1
			signal uudecodermenu
		end
		else uudecoder.uudecoders.longname = result

		REQUESTSTRING TITLE '"Enter a commandline for this uudecoder"' BODY '"'uucmdlinehelp'"' BT '"_Ok|_Cancel"' ID '"uu >%TmpFile FROM *"%MsgFilename*" TO *"%DestDir*""' MAXCHARS 256
		if rc ~= 0 then
		do
			uudecoder.count = uudecoder.count - 1
			signal uudecodermenu
		end
		else uudecoder.uudecoders.commandline = result

		call writecfg(cfgfile)
	end

	when choice = 'HELP' then
	do
		REQUESTNOTIFY TEXT '"Not implemented yet..."' BT '"_Ok"'
		/*call help('CFGuudecoder')*/
	end

	otherwise
	do
		do i = 1 to uudecoder.count
			if choice = uudecoder.i.longname then
			do
				REQUESTNOTIFY '"Do you want to edit\nor delete this item?"' '"_Edit|_Delete"'
				if result = 0 then
				do
					REQUESTNOTIFY '"Sure you want to remove\n'choice'\nas a uudecoder?"' '"_Yes|_No"'
					if result = 1 then
					do
						k = 1
						do j = 1 to uudecoder.count
							if uudecoder.j.longname ~= choice then
							do
								uudecoder.k.longname = uudecoder.j.longname
								uudecoder.k.shortname = uudecoder.j.shortname
								uudecoder.k.commandline = uudecoder.j.commandline
								k = k + 1
							end
						end
						uudecoder.count = uudecoder.count - 1
						call writecfg(cfgfile)
					end
				end
				else
				do
					REQUESTSTRING TITLE '"Edit uudecoder short name"' BODY '"I.e. ''UUOUT'' or ''UUXT''."' BT '"_Ok|_Cancel"' ID '"'uudecoder.i.shortname'"' MAXCHARS 40
					if rc = 0 then
					do
						uudecoder.i.shortname = result

						REQUESTSTRING TITLE '"Enter a long, descriptive name this uudecoder"' BODY '"I.e. ''uuOut v1.14 by Nicolas Dade''\nor ''UUxT v3.1 by Asher Feldman''"' BT '"_Ok|_Cancel"' ID '"'uudecoder.i.longname'"' MAXCHARS 256
						if rc = 0 then
						do
							uudecoder.i.longname = result

							tmpstr = escape(uudecoder.i.commandline) /* escape " -> *" & * -> ** */
		
							REQUESTSTRING TITLE '"Edit uudecoder commandline"' BODY '"'uucmdlinehelp'"' BT '"_Ok|_Cancel"' ID '"'tmpstr'"' MAXCHARS 256
							if rc = 0 then
							do
								uudecoder.i.commandline = result
								call writecfg(cfgfile)
							end
						end
					end
				end
			end
		end
	end
end

signal uudecodermenu

readcfg: procedure expose cfgfile tmpdir destdir uudecoder uuprogpath filenotes filerecog filetypecount filetype. thorport uudecoder.

call open(cf, cfgfile, 'R')

do until eof(cf)
subentry = ""
	entry = readln(cf)
	select
		when upper(entry) = "START" then
		do
			do until upper(subentry) = "END"
				subentry = readln(cf)
				select
					when upper(subword(subentry, 1, 1)) = 'TMPDIR:' then tmpdir = subword(subentry, 2)
					when upper(subword(subentry, 1, 1)) = 'DESTDIR:' then destdir = subword(subentry, 2)
					when upper(subword(subentry, 1, 1)) = 'UUDECODER:' then uudecoder = subword(subentry, 2)
					when upper(subword(subentry, 1, 1)) = 'UUPROGPATH:' then uuprogpath = subword(subentry, 2)
					when upper(subword(subentry, 1, 1)) = 'FILENOTES:' then if upper(subword(subentry, 2, 1)) = 'YES' then filenotes = 1
					when upper(subword(subentry, 1, 1)) = 'FILERECOG:' then if upper(subword(subentry, 2, 1)) = 'YES' then filerecog = 1
					otherwise nop
				end
			end
		end

		when upper(entry) = "FILETYPE" then
		do
			/* Read filetype configuration */
			filetypecount = filetypecount + 1
			actions = 0
			do until upper(subentry) = "END"
				subentry = readln(cf)
				select
					when upper(subword(subentry, 1, 1)) = 'NAME:' then filetype.filetypecount.name = subword(subentry, 2)
					when upper(subword(subentry, 1, 1)) = 'EXTENSIONS:' then filetype.filetypecount.ext = upper(subword(subentry, 2))
					when upper(subword(subentry, 1, 1)) = 'ACTIONNAME:' then
					do
						actions = actions + 1
						filetype.filetypecount.actionname.actions = subword(subentry, 2)
						subentry = readln(cf)
						filetype.filetypecount.actioncmdl.actions = subword(subentry, 2)
					end
					otherwise nop
				end
				filetype.filetypecount.actioncount = actions
			end
		end

		when upper(entry) = "UUDECODER" then
		do
			uudecoder.count = uudecoder.count + 1
			uudecoders = uudecoder.count

			do until upper(subentry) = "END"
				subentry = readln(cf)
				select
					when upper(subword(subentry, 1, 1)) = 'SHORTNAME:' then uudecoder.uudecoders.shortname = subword(subentry, 2)
					when upper(subword(subentry, 1, 1)) = 'LONGNAME:' then uudecoder.uudecoders.longname = subword(subentry, 2)
					when upper(subword(subentry, 1, 1)) = 'COMMANDLINE:' then uudecoder.uudecoders.commandline = subword(subentry, 2)
					otherwise nop
				end
			end
		end

		otherwise nop
	end
end

call close(cf)
return

writecfg: procedure expose tmpdir destdir uudecoder uuprogpath filenotes filerecog filetypecount filetype. thorport thorpath uudecoder.
          parse arg cfgfile

call open(cf, cfgfile, 'W')
call writeln(cf, 'START')
call writeln(cf, 'Tmpdir: '||tmpdir)
call writeln(cf, 'Destdir: '||destdir)
call writeln(cf, 'UUDecoder: '||uudecoder)
call writeln(cf, 'UUProgPath: '||uuprogpath)
if(filenotes) then call writeln(cf, 'Filenotes: '||YES)
else call writeln(cf, 'Filenotes: '||NO)
if(filerecog) then call writeln(cf, 'Filerecog: '||YES)
else call writeln(cf, 'Filerecog: '||NO)
call writeln(cf, 'END')
call writeln(cf, '')

if filetypecount > 0 then 
do i = 1 to filetypecount
	call writeln(cf, 'FILETYPE')
	call writeln(cf, 'Name: 'filetype.i.name)
	call writeln(cf, 'Extensions: 'filetype.i.ext)
	if filetype.i.actioncount > 0 then
	do j = 1 to filetype.i.actioncount
		call writeln(cf, 'ActionName: 'filetype.i.actionname.j)
		call writeln(cf, 'ActionCommandline: 'filetype.i.actioncmdl.j)
	end
	call writeln(cf, 'END')
	call writeln(cf, '')
end

if (uudecoder.count > 0) then
do i=1 to uudecoder.count
	call writeln(cf, 'UUDECODER')
	call writeln(cf, 'ShortName: 'uudecoder.i.shortname)
	call writeln(cf, 'LongName: 'uudecoder.i.longname)
	call writeln(cf, 'Commandline: 'uudecoder.i.commandline)
	call writeln(cf, 'END')
	call writeln(cf, '')
end

call close(cf)

if cfgfile = 'ENV:Thor/UUDecode.cfg' then do
	address(command)
	'Copy "'cfgfile'" "ENVARC:Thor/UUDecode.cfg" QUIET'
	end

return

/* The following procedure was actually made by Magne stlyngen... */

escape: procedure
	parse arg oldstr

	newstr = ''
	strlen = length(oldstr)
	do n = 1 to strlen
		ch = substr(oldstr,n,1)
		select
			when ch = '*' then newstr = newstr||'**'
			when ch = '"' then newstr = newstr||'*"'
			otherwise newstr = newstr||ch
		end
	end

	return newstr
